%define enable_japanese 1

%define qtdir /usr/lib/qt-1.45
%define sourcedir stable/%{version}/distribution/tar/generic/source
%define prefix %{_prefix}
%define pamservice kde

Name: kdebase
Icon: kde-icon.xpm
URL: http://www.kde.org
Summary: Core files for the K Desktop Environment (KDE).
Version: 1.1.2
Release: 48j1
Epoch: 5
Source: ftp://ftp.kde.org/pub/kde/{sourcedir}/%{name}-%{version}.tar.bz2
Source1: KDE.session.gnome
Source2: Autorun.kdelnk
Source3: http://akpage.heberguement-gratuit.com/AKH/m30-projects/p00-kpanel2/kpanel2.tar.bz2
Source4: kappfinder.consolehelper
Patch0: kdebase-1.1.2-redhat.patch
Patch1: kdebase-1.1-waitkdm.patch
Patch2: kdebase-1.1.2-dodesktop.patch
Patch3: kdebase-1.1.2-saveoption.patch
Patch5: kdebase-1.1.2-bigendian.patch
Patch6: kdebase-glxMesa.patch
Patch9: kdebase-1.1.2-fixdebug.patch
Patch12: konsole-escseqs.patch
Patch13: kdebase-1.1.2-FHS.patch
Patch14: kdebase-kpanel1.patch
# Japanese patch
Patch20: kdebase-ja.19991029.diff.gz
Group: User Interface/Desktops
Copyright: GPL
BuildRoot: %{_tmppath}/%{name}-buildroot
Requires: kdesupport kdelibs >= 1.1.2-19 tar >= 1.13, /etc/X11/xdm/Xsession
BuildPrereq: kdelibs-devel >= 1.1.2-19 qt1x-devel tar >= 1.13
%ifnarch ia64
BuildPrereq: compat-egcs-c++
%endif
Prefix: %{_prefix}
Excludearch: ia64
Prereq: XFree86-xfs

%description
The K Desktop Environment (KDE) is a GUI desktop for the X Window
System. The kdebase package contains the core applications for KDE:
kdm, a replacement for xdm (an X display manager); kwm, a KDE window
manager; kfm, a file manager, Web browser, FTP client, etc.; konsole,
an xterm replacement; kpanel, an application starter and desktop
pager; kaudio, an audio server; kdehelp, a viewer for KDE help files,
info and man pages; plus other KDE components (kcheckpass, kikbd, kvt,
kscreensaver, kcontrol, kfind, kfontmanager, kmenuedit, and
kappfinder).

If you want to use KDE, you'll need to install kdebase, kdelibs and
kdesupport. You may also want to install the other KDE packages:
kdeadmin, kdegames, kdegraphics, kdemultimedia, kdenetwork,
kdesupport, and kdeutils.

%package lowcolor-icons
Summary: Low color (8-bit display friendly) icons for KDE.
Group: User Interface/Desktops
Requires: kdebase

%description lowcolor-icons
The default icons in K Desktop Environment (KDE) version 1.1.2 are
color intensive, and can quickly use up all available colors on an
8-bit (256 color) display.  If you have such a display and you're
using KDE, you should install this package, because it will provide a
more efficient allocation of colors when KDE displays icons.

%package 3d-screensavers
Summary: 3-D (OpenGL) screensavers for the K Desktop Environment.
Group: User Interface/Desktops
Requires: kdebase, qt1x-GL
BuildPrereq: qt1x-GL, qt1x-devel, compat-egcs-c++

%description 3d-screensavers
3-D (OpenGL) screensavers for the K Desktop Environment (KDE).

%prep
%setup -q -n kdebase
%patch14 -p1 -b .kpanel1
mv kpanel kpanel1
tar xIf %{SOURCE3}
%patch0 -p1 -b .redhat
%patch1 -p1 -b .waitkdm
%patch2 -p1 -b .dodesktop
%patch3 -p1 -b .saveoption
%patch5 -p1 -b .bigendian
#%patch6 -p1 -b .glxmesa
%patch9 -p1 -b .fixdebug
%patch12 -p1 -b .esc
%patch13 -p1 -b .FHS
%if %{enable_japanese}
%patch20 -p1 -b .jp
%endif

%build
export KDEDIR=%{prefix} QTDIR=%{qtdir}
%ifnarch ia64
export CXX="egcs++ -L/usr/lib" CC="egcs -L/usr/lib"
%else
export CXX="g++" CC="gcc"
%endif
FLAGS="$RPM_OPT_FLAGS -DNDEBUG -DNO_DEBUG"

make -f Makefile.cvs

if [ -x /usr/bin/getconf ]; then
  CPUS=`getconf _NPROCESSORS_ONLN`
fi
if test "x$CPUS" = "x" -o "x$CPUS" = "x0"; then
  CPUS=1
fi

[ -f configure.in ] && libtoolize --copy --force
CFLAGS="$FLAGS" CXXFLAGS="$FLAGS" ./configure \
  --prefix=%{prefix} \
  --with-pam=kde \
  --with-gl \
  --with-xdmdir=/etc/X11/xdm \
  --x-libraries=/usr/X11R6/lib \
  --x-includes=/usr/X11R6/include \
  --with-install-root=$RPM_BUILD_ROOT

make -j $CPUS CXX="$CXX" CC="$CC" \
              CFLAGS="$FLAGS" CXXFLAGS="$FLAGS"

# set up locolor icons
cd pics
tar xzf locolor-icons.tar.gz

%install
rm -rf $RPM_BUILD_ROOT

make install RUN_KAPPFINDER=no \
     ac_xdmdir=$RPM_BUILD_ROOT/etc/X11/xdm

# install lowcolor icons
mkdir -p $RPM_BUILD_ROOT%{_prefix}/share/icons/locolor
cp pics/share/icons/* $RPM_BUILD_ROOT%{_prefix}/share/icons/locolor

# do NOT make kvt suid root
chmod 0755 $RPM_BUILD_ROOT%{_prefix}/bin/kvt

# make kcheckpass suid root
chmod 1755 $RPM_BUILD_ROOT%{_prefix}/bin/kcheckpass

# remove SUID bit from konsole_grantpty
chmod 0755 $RPM_BUILD_ROOT%{_prefix}/bin/konsole_grantpty

#install pam configuration file
mkdir -p $RPM_BUILD_ROOT/etc/pam.d
install -c -m 0644 $RPM_BUILD_DIR/kdebase/kde.pamd \
	$RPM_BUILD_ROOT/etc/pam.d/%{pamservice}

# create symlink to en
( cd $RPM_BUILD_ROOT/usr/share/doc/HTML && ln -nfs en default )

# remove /etc/X11/xdm, It's ready in XFree86-xdm
# kdm and xdm will share the xdm here
rm -rf $RPM_BUILD_ROOT/etc/X11/xdm

cat >$RPM_BUILD_ROOT%{_prefix}/bin/kfmbrowser <<EOF
#!/bin/sh
exec /usr/bin/kfmclient openURL \$*
EOF
chmod 0755 $RPM_BUILD_ROOT%{_prefix}/bin/kfmbrowser

# fix kappfinder script for relocatability
{
	pushd $RPM_BUILD_ROOT%{_prefix}/bin
	sed -e 's.\$(prefix).\$KDEDIR.g' kappfinder > kappfinder.temp
	sed -e 's.\$INSTPATH./usr.g' kappfinder.temp >kappfinder
	sed -e 's.\${install_root}..g' kappfinder > kappfinder.temp
	mv -f kappfinder.temp kappfinder
	chmod 0755 ./kappfinder
	popd
}

# make symlink for our applnk directory and GNOME directory
{
        pushd $RPM_BUILD_ROOT%{prefix}/share/applnk
        mkdir -p $RPM_BUILD_ROOT/etc/X11/applnk
        cat > $RPM_BUILD_ROOT/etc/X11/applnk/.directory << EOF
# KDE Config File
[KDE Desktop Entry]
Icon=/usr/share/pixmaps/redhat/shadowman-round-32.xpm
MiniIcon=/usr/share/pixmaps/redhat/shadowman-round-mini.xpm
Name=Red Hat
EOF

        ln -sf ../../../etc/X11/applnk redhat
        ln -sf ../gnome/apps gnome

        popd
}

# menu layout changes
{
	pushd $RPM_BUILD_ROOT%{_prefix}/share/applnk
	mv Krefresh.kdelnk Kfind.kdelnk Trash.kdelnk Utilities/
	popd
}

# fix konsole /opt/kde hardcode
{
	pushd konsole/other
	perl -pi -e "s|/opt/kde|/usr|g" *
	popd
}

chmod 4755 $RPM_BUILD_ROOT/usr/bin/kcheckpass

# remove some icons that conflict with fvwm2-icons
rm $RPM_BUILD_ROOT%{_prefix}/share/icons/bell.xpm
rm $RPM_BUILD_ROOT%{_prefix}/share/icons/mini/mini.*

{
	pushd $RPM_BUILD_ROOT
	find . -type d | sed '1,2d;s,^\.,\%attr(-\,root\,root) \%dir ,' > \
		$RPM_BUILD_DIR/file.list.%{name}

	find . -type f | sed -e 's,^\.,\%attr(-\,root\,root) ,' \
		-e '/\/config\//s|^|%config|' >> \
		$RPM_BUILD_DIR/file.list.%{name}

	find . -type l | sed 's,^\.,\%attr(-\,root\,root) ,' >> \
		$RPM_BUILD_DIR/file.list.%{name}

	egrep -v "locolor|kmorph3d.kss|kspace.kss|kpipes.kss|pam.d/kde" $RPM_BUILD_DIR/file.list.%{name} > \
		$RPM_BUILD_DIR/file.list.%{name}.temp
	mv $RPM_BUILD_DIR/file.list.%{name}.temp \
		$RPM_BUILD_DIR/file.list.%{name}

	echo "%docdir /usr/doc/kde" >> \
		$RPM_BUILD_DIR/file.list.%{name}

	popd
}

# install gdm session support
mkdir -p $RPM_BUILD_ROOT/etc/X11/gdm/Sessions
install -c -m 755 %{SOURCE1} \
	$RPM_BUILD_ROOT/etc/X11/gdm/Sessions/KDE

mkdir -p $RPM_BUILD_ROOT/etc/skel/Desktop/Autostart
install -c -m 644 %{SOURCE2} $RPM_BUILD_ROOT/etc/skel/Desktop/Autostart

# install the linux console fonts
install -d -m 755 $RPM_BUILD_ROOT/usr/X11R6/lib/X11/fonts/misc
install -c -m 644 konsole/other/*.pcf.gz \
	$RPM_BUILD_ROOT/usr/X11R6/lib/X11/fonts/misc

mkdir -p $RPM_BUILD_ROOT/usr/sbin
mv $RPM_BUILD_ROOT/usr/bin/kappfinder $RPM_BUILD_ROOT/usr/sbin
ln -s consolehelper $RPM_BUILD_ROOT/usr/bin/kappfinder
mkdir -p $RPM_BUILD_ROOT/etc/security/console.apps
install -c -m644 %{SOURCE4} $RPM_BUILD_ROOT/etc/security/console.apps/kappfinder

%clean
rm -rf $RPM_BUILD_ROOT $RPM_BUILD_DIR/file.list.%{name}

%post
cd /usr/X11R6/lib/X11/fonts/misc && /usr/X11R6/bin/mkfontdir

%postun
if [ "$1" = "0" ]; then
  cd /usr/X11R6/lib/X11/fonts/misc && /usr/X11R6/bin/mkfontdir
fi

%files -f ../file.list.%{name}
%defattr(-,root,root)
%config %attr(-,root,root) /etc/X11/gdm/Sessions/KDE
%config %attr(-,root,root) /etc/security/console.apps/kappfinder
%attr(-,root,root) /usr/X11R6/lib/X11/fonts/misc/*
%attr(-,root,root) %config /etc/pam.d/kde

%files lowcolor-icons
%defattr(-,root,root)
/usr/share/icons/locolor

%files 3d-screensavers
%defattr(-,root,root)
%{_prefix}/bin/kmorph3d.kss
%{_prefix}/bin/kspace.kss
%{_prefix}/bin/kpipes.kss

%changelog
* Thu Aug 31 2000 Yukihiro Nakai <ynakai@redhat.com>
- Add Japanese patch

* Fri Aug 25 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Prereq: XFree86-xfs and usr /usr/X11R6/bin/mkfontdir rather than
  just mkfontdir, gets rid of error message during installation
  (Bug #16929)

* Mon Aug 21 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Make kappfinder use consolehelper (Bug #16576)
- Fix permissions on kcheckpass (Bug #16578)

* Sun Aug 13 2000 Than Ngo <than@redhat.com>
- kpanel1 as default
- fix kdm for setting correct PATH
- fix de/kwm.po file to show string correct in german language

* Wed Aug 9 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Oops, applying the latest patch instead of just putting it in the
  package might be a good idea...

* Wed Aug 9 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix a possible DOS attack in startkde
- Update to KDE_1_1_BRANCH, fixes 3 kfm bugs and 2 klipper bugs
  and obsoletes 5 of our patches.

* Sat Aug 5 2000 Than Ngo <than@redhat.de>
- fix to set LANG correct
- fix kdm config file to set correct background color
- rebuilt against the new libpng-1.0.8

* Thu Aug  3 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Don't require XFree86-xdm; require Xsession instead.

* Tue Aug 1 2000 Than Ngo <than@redhat.de>
- fix for reading config files in /etc/X11/xdm
- add XFree86-xdm in requires

* Tue Aug  1 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- move in kpanel2 (http://akpage.hebergement-gratuit.com/AKH/m30-projects/
  p00-kpanel2/)
- port the .desktop patch to kpanel2
- support ia64 in the specfile; leave it excluded (compiler bugs)
- some fixes

* Sun Jul 30 2000 Than Ngo <than@redhat.de>
- rebuilt against compat-egcs-c++
- cleanup specfile
- added missing symlink (en->default)
- fix kdehelp to read manpages and info files under /usr/share

* Mon Jun 5 2000 Than Ngo <than@redhat.de>
- rebuild or 7.0

* Mon Jun  5 2000 Nalin Dahyabhai <nalin@redhat.com>
- modify PAM setup to use system-auth

* Fri Jun  2 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- current KDE_1_1_BRANCH; I've fixed up compilation with glibc 2.2 and
  perl 5.6.0 there.
- fix spec file for 7.0

* Wed Mar  8 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- Fix security problem: Users with /bin/false as shell could log in with kdm
  (Bug #10055)

* Thu Mar  2 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- Don't start kbgndwm before copying settings (Bug #9922)

* Mon Feb 21 2000 Preston Brown <pbrown@redhat.com>
- recompile with proper kde_htmldir.
- really fix konsole keybindings to match xterm / debian keyboard standard.
- re-enable BS sends DEL by default.

* Wed Feb 16 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- Current KDE_1_1_BRANCH. This fixes the kdehelp i18n bug.

* Fri Feb 11 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- Set default->en symlink for HTML docs (Bug #9363)

* Thu Feb 10 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- current KDE_1_1_BRANCH
- add /usr/bin/kfmbrowser script. This is a shortcut to kfmclient OpenURL, and
  is used by the htmlbrowser script (kde2libs)

* Wed Feb  9 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- fix up and re-enable the boolterm patch
- remove autorun from startkde, put a kdelnk in /etc/skel/Desktop/Autostart
  instead. Makes it easier for an individual user to turn it on/off. 
- require kdelibs >= 1.1.2-13, which adapts readBoolEntry to the needs of
  boolterm
- BuildPrereq kdelibs-devel
- Disable "BS sends DEL" by default; it's better with the current ncurses
  and termcap fixes.

* Mon Feb  7 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- Fix up the fixdebug patch
- Disable the "Terminal= is bool" patch. It breaks too many things right now.

* Sun Feb  6 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- Fix konsole escape sequences (Bug #9161)
- Fix kappfinder (Bug #7765 with additional fixes)

* Fri Feb 04 2000 Preston Brown <pbrown@redhat.com>
- read "Terminal=" entry in desktop entries as a bool value, not a string
- fix kappfinder
- fix tar file browsing

* Thu Feb 03 2000 Preston Brown <pbrown@redhat.com>
- more debug output removed

* Tue Feb 01 2000 Preston Brown <pbrown@redhat.com>
- rebuild to fix glibc dependency issue.

* Mon Jan 24 2000 Preston Brown <pbrown@redhat.com>
- fix :: problem in path when using KDM (#3677)

* Tue Jan 18 2000 Preston Brown <pbrown@redhat.com>
- whoops we weren't applying patch #9.

* Tue Jan 18 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Use /dev/urandom instead of /dev/random (Bug #8233)

* Mon Jan 17 2000 Preston Brown <pbrown@redhat.com>
- remove some debug output that was done with (s)printf (#5938)
- fix lowcolor icon package (#6809)

* Mon Jan 17 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Add eject and kfmdir patches from Harald Hoyer <harald@redhat.de>
- return the real descriptions the build system messed up

* Fri Jan 14 2000 Bill Nottingham <notting@redhat.com>
- rebuild to fix Mesa dependencies

* Sat Jan  8 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- Fix bug in TryExec handling - kpanel no longer hangs the X server when
  accessing the GNOME menu with recent GNOME versions.

* Fri Jan  7 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- KDE_1_1_BRANCH
- Mark /etc/pam.d/kde as config file (#8242)
- Enable building the GL screensavers (to separate package) now that we
  have glxMesa, fix compilation with glxMesa
- Adapt to 6.2 environment
- remove kdm security fix (now in base, along with others)
- work around makefile bug (install-strip breakage)

* Mon Nov 29 1999 Preston Brown <pbrown@redhat.com>
- kdm security fix
- fix to dodesktop patch so that context menu is correct
- fix TryExec (#5454)

* Tue Oct 12 1999 Preston Brown <pbrown@redhat.com>
- use /proc/devices for sound support discovery

* Sun Oct 10 1999 Matt Wilson <msw@redhat.com>
- included patch for sound on big endian machines from Dave Miller

* Mon Sep 27 1999 Preston Brown <pbrown@redhat.com>
- fix check for /etc/sysconfig/soundcard in startkde

* Thu Sep 23 1999 Preston Brown <pbrown@redhat.com>
- clean up files in /tmp from startkde
- mark doc files as such

* Tue Sep 21 1999 Preston Brown <pbrown@redhat.com>
- start autorun if present in startkde
- check for configured soundcard before running sound services

* Mon Sep 20 1999 Preston Brown <pbrown@redhat.com>
- made kdelnks display Name property if they are of type Link

* Thu Sep 16 1999 Preston Brown <pbrown@redhat.com>
- moved png handling here (from kdelibs)
- changed low color icon directory name to locolor

* Tue Sep 14 1999 Preston Brown <pbrown@redhat.com>
- added optional session management to logout dialog
- include GNOME menus

* Mon Sep 13 1999 Preston Brown <pbrown@redhat.com>
- added link to /etc/X11/applnk, .directory file
- included lowcolor icon sub-package
- enable .desktop file access

* Fri Sep 10 1999 Preston Brown <pbrown@redhat.com>
- customized startkde script to set up user environment if not present.
- mention kthememgr in description.

* Wed Sep 08 1999 Preston Brown <pbrown@redhat.com>
- upgraded to 1.1.2 release
- kvt is back
- kde icon included
- linux console fonts included

* Thu Jul 15 1999 Preston Brown <pbrown@redhat.com>
- PAM console logout problem solved.

* Mon Jul 12 1999 Preston Brown <pbrown@redhat.com>
- now includes screensaver password security fix

* Fri Jun 11 1999 Preston Brown <pbrown@redhat.com>
- snapshot, includes kde 1.1.1 + fixes
- kvt removed for security reasons.  It is a steaming pile of...

* Mon Apr 19 1999 Preston Brown <pbrown@redhat.com>
- last snapshot before release

* Fri Apr 16 1999 Preston Brown <pbrown@redhat.com>
- today's snapshot makes kfm a bit nicer and some other fixes
- moved default rc files to kdesupport

* Thu Apr 15 1999 Preston Brown <pbrown@redhat.com>
- SUID bit removed from konsole_grantpty -- not needed w/glibc 2.1

* Wed Apr 14 1999 Preston Brown <pbrown@redhat.com>
- built with today's snapshot -- had to rebuild to fix pam problems.

* Tue Apr 13 1999 Preston Brown <pbrown@redhat.com>
- new snapshot fixes mimetype video/x-flic problem

* Mon Apr 12 1999 Preston Brown <pbrown@redhat.com>
- latest stable snapshot

* Fri Apr 09 1999 Preston Brown <pbrown@redhat.com>
- removed bell.xpm (used to be in fvwm2-icons, don't want installer to see
- this previous connection and autoselect kdebase for upgrade).

* Tue Mar 23 1999 Preston Brown <pbrown@redhat.com>
- moved gdm patch

* Mon Mar 22 1999 Preston Brown <pbrown@redhat.com>
- added gdm session control file

* Fri Mar 19 1999 Preston Brown <pbrown@redhat.com>
- added pam-console stuff to kde pam file

* Wed Feb 24 1999 Preston Brown <pbrown@redhat.com>
- Injected new description and group.

* Mon Feb 07 1999 Preston Brown <pbrown@redhat.com>
- upgraded to KDE 1.1 final.

* Tue Jan 19 1999 Preston Brown <pbrown@redhat.com>
- updated macros for RPM 3.0, removed red hat logo.

* Tue Jan 05 1999 Preston Brown <pbrown@redhat.com>
- re-merged from Duncan Haldane's stuff
